'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _OverlayTrigger = require('./OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var Option = (function (_Component) {
  _inherits(Option, _Component);

  function Option() {
    _classCallCheck(this, Option);

    _Component.apply(this, arguments);
  }

  Option.prototype.render = function render() {
    var _props = this.props;
    var selected = _props.selected;
    var item = _props.item;
    var index = _props.index;
    var selectItem = _props.selectItem;
    var hasIcon = _props.hasIcon;
    var focused = _props.focused;
    var tooltip = _props.tooltip;

    var classes = {
      'selected': selected,
      'focused': focused
    };

    var _tooltip = _react2['default'].createElement(
      _Tooltip2['default'],
      null,
      item.text
    );

    return tooltip.show == true ? _react2['default'].createElement(
      _OverlayTrigger2['default'],
      { placement: tooltip.placement, overlay: _tooltip },
      _react2['default'].createElement(
        'div',
        {
          className: _classnames2['default']('myselect-item', classes, 'text-hidden'),
          onClick: function () {
            selectItem(item);
          }
        },
        hasIcon && this.generateIcon(),
        item.text
      )
    ) : _react2['default'].createElement(
      'div',
      {
        className: _classnames2['default']('myselect-item', classes),
        onClick: function () {
          selectItem(item);
        }
      },
      hasIcon && this.generateIcon(),
      item.text
    );
  };

  // 生成icon

  Option.prototype.generateIcon = function generateIcon() {
    // 样式
    var classes = {};
    var _props2 = this.props;
    var type = _props2.type;
    var hasIcon = _props2.hasIcon;
    var selected = _props2.selected;

    switch (type) {
      case 'single':
        classes = _classnames2['default']('radio-inner', { 'checked': selected });break;
      case 'multiple':
        classes = _classnames2['default']('checkbox-inner', { 'checked': selected });break;
    }
    return _react2['default'].createElement('i', { className: classes });
  };

  return Option;
})(_react.Component);

Option.propTypes = {
  /**
   * @private
   * 从select 传递的本身
   */
  item: _react2['default'].PropTypes.object,
  /**
   * 是否选中
   * @type {bool} 
   */
  selected: _react2['default'].PropTypes.bool,

  /**
   * 复选还是单选？
   * @type {single / multiple}
   */
  type: _react2['default'].PropTypes.oneOf(["single", "multiple"]),
  /**
   * 选中事件
   * @type {func}
   */
  selectItem: _react2['default'].PropTypes.func,
  /**
   *  光标移动位置
   * @type {number}
   */
  index: _react2['default'].PropTypes.number,
  /**
   * 是否有icon
   * @type {bool}
   */
  hasIcon: _react2['default'].PropTypes.bool,
  /**
   *  focused 是否添加 focused样式
   */
  focused: _react2['default'].PropTypes.bool,

  /**
   * 选项提示信息
   * @type {Object}
   */
  tooltip: _react2['default'].PropTypes.shape({
    show: _react2['default'].PropTypes.bool,
    placement: _react2['default'].PropTypes.oneOf(["left", "right", "top", "bottom"])
  })
};

exports['default'] = Option;
module.exports = exports['default'];